	SUBROUTINE GREETINGS(myid,num)

	IMPLICIT NONE
        INCLUDE 'mpif.h'
	INTEGER myid,num

	INTEGER len
	PARAMETER (len = MPI_MAX_PROCESSOR_NAME+1)
	CHARACTER*(len) name,chbuf
	INTEGER stat(MPI_STATUS_SIZE),ierr,i,dest,reslen

	CALL MPI_GET_PROCESSOR_NAME(name,reslen,ierr)
	IF(myid.eq.0) THEN
	  WRITE(*,*) myid, ' runs on  ',name
	  DO i=1,num-1
	    CALL MPI_RECV(chbuf,len,MPI_CHARACTER,MPI_ANY_SOURCE,
     &             MPI_ANY_TAG,MPI_COMM_WORLD, stat,ierr)
	    WRITE(*,*) stat(MPI_SOURCE), ' runs on  ',chbuf
	  ENDDO
	ELSE
	  dest = 0
	  CALL MPI_SEND(name,len,MPI_CHARACTER,dest,myid,
     &            MPI_COMM_WORLD,ierr)
	ENDIF

	RETURN
	END
